#########################################
#    1000 bornes                        #
#      v1.0.1  (13/08/2010) by jolo2    #
#  Contact: jolo2@jolo2.eu              #
#           irc.jolo2.eu/#jolo2         #
#  License: GNU General Public License  #
#########################################

########### TODO ###########
#    Maybe the help ? :D   #
############################

#
#    This file is part of "1000 bornes".
#
#    "1000 bornes" is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    "1000 bornes" is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with "1000 bornes".  If not, see <http://www.gnu.org/licenses/>.
#

package require Tcl 8.5

proc shuffle { list } {
	set n [llength $list]
	for { set i 1 } { $i < $n } { incr i } {
		set j [expr { int( rand() * $n ) }]
		set temp [lindex $list $i]
		lset list $i [lindex $list $j]
		lset list $j $temp
	}
	return $list
}
 
##########################################################################
# ^ Found on http://code.activestate.com/recipes/65435-shuffling-a-list/ #
##########################################################################
if {[info commands ::1000bornes::uninstall] ne ""} {
	::1000bornes::uninstall
}
namespace eval "1000bornes" {

	variable chan "#foobar"
	variable language "fr"

	variable maxplayers 6; # This is the maximum number of players.
	variable timeoutstart 120; # This is after how much time the game start.
	variable timeoutplayer 120; # That's when a player is excluded from the game.
	variable timeoutplayerrecall 60; # That's the first recall of the player to play.
	variable timeoutplayerrecalllast 100; # That's the last recall of the player

	variable numbercards {{OutGas 3} {Flat 3} {Accident 3} {MaxSpeed 4} {RedLight 5} {Gas 6} {SpareWheel 6} {Repairing 6} {EndMaxSpeed 6} {GreenLight 14} {Puncture-Proof 1} {Tank 1} {AceDriver 1} {Priority 1} {200 4} {100 12} {75 10} {50 10} {25 10}}
	# This define how many cards of each type must be in the cards that will be given to the players.
	
	# Theses are the defaults values for the commands.
	variable join {"!join"}
	variable play {"!play"}
	variable throw {"!throw"}
	variable giveup {"!giveup"}
	variable startcmds {"!start"}
	variable stopcmds {"!stop"}
	variable statutcmds {"!statut"}
	variable cardscmds {"!cards"}
	variable turncmds {"!turn"}
	variable timecmds {"!time"}
	variable helpcmds {"!help"}
	variable secretweaponname "Secret(s) Weapon(s)"

	#########################################################
	# Don't touch anything below this if you don't know tcl #
	#########################################################
	
	variable timestarted 0;
	variable started 0;
	variable ingame 0;
	variable players {};
	variable timeouts {}
	variable playerinfo {};
	variable timerstart "";
	variable playernow 0;
	variable cards "";
	variable secretweaponskip {};

	if {[file isfile "scripts/1000bornes/language/language-[set ::1000bornes::language].tcl"]} {
		source "scripts/1000bornes/language/language-[set ::1000bornes::language].tcl";
	}
	proc say {chan msg args} {
		set index [lsearch -index 0 $::1000bornes::language "$msg"]
		if {$index>-1} {
			set msg [lindex $::1000bornes::language $index 1]
		}
		if {$args ne ""} {
			set numberargs "1"
			foreach arg $args {
				set msg [string map [list %$numberargs $arg] $msg];
				incr numberargs;
			}
		}
		putquick "PRIVMSG $chan :$msg"
	}
	proc notc {nick msg args} {
		set index [lsearch -index 0 $::1000bornes::language "$msg"]
		if {$index>-1} {
			set msg [lindex $::1000bornes::language $index 1]
		}
		if {$args ne ""} {
			set numberargs "1"
			foreach arg $args {
				set msg [string map [list %$numberargs $arg] $msg];
				incr numberargs;
			}
		}
		putquick "NOTICE $nick :$msg"
	}

	foreach joincmd $::1000bornes::join {
		bind pubm -|- "$::1000bornes::chan %$joincmd" ::1000bornes::game;
		bind pubm -|- "$::1000bornes::chan %$joincmd *" ::1000bornes::game;
	}
	foreach playcmd $::1000bornes::play {
		bind pubm -|- "$::1000bornes::chan %$playcmd *" ::1000bornes::play;
	}
	foreach throwcmd $::1000bornes::throw {
		bind pubm -|- "$::1000bornes::chan %$throwcmd *" ::1000bornes::throw;
	}
	foreach giveupcmd $::1000bornes::giveup {
		bind pubm -|- "$::1000bornes::chan %$giveupcmd" ::1000bornes::giveupcmd;
	}
	foreach cardscmd $::1000bornes::cardscmds {
		bind pubm -|- "$::1000bornes::chan %$cardscmd" ::1000bornes::cards;
	}
	foreach turncmd $::1000bornes::turncmds {
		bind pubm -|- "$::1000bornes::chan %$turncmd" ::1000bornes::turn;
	}
	foreach timecmd $::1000bornes::timecmds {
		bind pubm -|- "$::1000bornes::chan %$timecmd" ::1000bornes::time;
	}
	foreach startcmd $::1000bornes::startcmds {
		bind pubm n|o "$::1000bornes::chan %$startcmd" ::1000bornes::startcmd;
	}
	foreach stopcmd $::1000bornes::stopcmds {
		bind pubm n|o "$::1000bornes::chan %$stopcmd" ::1000bornes::stop;
	}
	foreach statutcmd $::1000bornes::statutcmds {
		bind pubm -|- "$::1000bornes::chan %$statutcmd" ::1000bornes::statut;
	}
	foreach helpcmd $::1000bornes::helpcmds {
		bind pubm -|- "$::1000bornes::chan %$helpcmd" ::1000bornes::helpcmd;
	}
	bind part -|- "$::1000bornes::chan *!*@*" ::1000bornes::giveuppart;
	bind sign -|- "$::1000bornes::chan *!*@*" ::1000bornes::giveuppart;
	bind kick -|- "$::1000bornes::chan * *" ::1000bornes::kickexcl;
	bind nick -|- "$::1000bornes::chan *" ::1000bornes::nick;
	proc helpcmd {nick host hand chan args} {
		::1000bornes::notc $nick "Feature not implemented yet."
	}
	proc nick {nick host hand chan newnick} {
		if {[lsearch -exact -nocase $::1000bornes::players $nick]>-1} {
			lset ::1000bornes::players "[lsearch -exact -nocase $::1000bornes::players $nick]" $newnick;
			if {$::1000bornes::ingame} {
				lset ::1000bornes::playerinfo "[lsearch -exact -nocase -index 0 $::1000bornes::playerinfo $nick]" "0" $newnick;
			}
		}
	}
	proc kmcolor {km} { 
		if {$km < 100} { return "$km" }
		if {$km < 200} { return "\00310$km\003" }
		if {$km < 300} { return "\00314$km\003" }
		if {$km < 400} { return "\00313$km\003" }
		if {$km < 500} { return "\00307$km\003" }
		if {$km < 600} { return "\00306$km\003" }
		if {$km < 700} { return "\00303$km\003" }
		if {$km < 800} { return "\00302$km\003" }
		if {$km < 900} { return "\00305$km\003" }
		if {$km < 1000} { return "\00304$km\003" }
		return "$km"
	}
	proc secretweaponadd {km} {
		if {$km < 700} { return 300 
		} elseif {$km < 800} { return 200 
		} elseif {$km < 900} { return 100 
		} elseif {$km < 925} { return 75 
		} elseif {$km < 950} { return 50 
		} elseif {$km < 975} { return 25 }
		return 0;
	}
	proc startcmd {nick host hand chan args} {
		if {$::1000bornes::timerstart ne ""} {
			killutimer $::1000bornes::timerstart;
		}
		if {!$::1000bornes::ingame} {
			::1000bornes::start
		}
	}
	#####################
	#  The game itself  #
	#####################
	proc turn {nick host hand chan args} {
		if {[lindex $::1000bornes::playerinfo $::1000bornes::playernow] ne {}} {
			set player [lindex $::1000bornes::playerinfo $::1000bornes::playernow]
			::1000bornes::say $::1000bornes::chan "It's the turn of %1." [lindex $player 0];
		}
	}
	proc time {nick host hand chan args} {
		if {$::1000bornes::timestarted!=0} {
			if {[set diff [expr [clock seconds]-$::1000bornes::timestarted]]>=3600} {
				set time [clock format $diff -format $::1000bornes::timeformatwithhour -gmt 1]
			} elseif {[set diff [expr [clock seconds]-$::1000bornes::timestarted]]>60} {
				set time [clock format $diff -format $::1000bornes::timeformatwithouthour -gmt 1]
			} else {
				set time [clock format $diff -format $::1000bornes::timeformatsecondsonly -gmt 1]
			}
			::1000bornes::say $::1000bornes::chan "The game has began for %1." $time
		}
	}
	proc cards {nick host hand chan args} {
		if {[lsearch -exact -nocase $::1000bornes::players $nick]>-1} {
			set player [lindex $::1000bornes::playerinfo [lsearch -exact -nocase $::1000bornes::players $nick]]
			set playercards [lindex $player 1]
			set speedometer [lindex $player 2]
			set limited [lindex $player 3]
			set statut [lindex $player 4]
			set secretweapon [lindex $player 5]
			set cardsofplayer {}
			foreach cardofplayer $playercards {
				lappend cardsofplayer "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $cardofplayer]] 3][lindex $cardofp 1]\003";
			}
			::1000bornes::notc $nick "Your cards are : %1." $cardsofplayer;
		}
	}
	proc statut {nick host hand chan args} {
		if {$::1000bornes::ingame} {
			foreach player $::1000bornes::playerinfo {
				set playercards [lindex $player 1]
				set speedometer [lindex $player 2]
				set limited [lindex $player 3]
				set statut [lindex $player 4]
				set secretweapon [lindex $player 5]
				set cardsofplayer {}
				set playercard2 {}
				set add "";
				if {$limited} {
					set add "$add \003[lindex [set limit [lsearch -index 0 -inline $::1000bornes::cardsname "MaxSpeed"]] 3][lindex $limit 2]\003"
				}
				if {[llength $secretweapon]>0} {
					set secretweapons [list ", $::1000bornes::secretweaponname :"];
					foreach weapon $secretweapon {
						lappend secretweapons "\003[lindex [set weapon1 [lsearch -index 0 -inline $::1000bornes::cardsname $weapon]] 3][lindex $weapon1 2]\003,";
					}
					set add "$add[string trimright [join $secretweapons] ,]";
				}
				::1000bornes::say $::1000bornes::chan "%1 | Speedometer : %2, Statut : %3" [lindex $player 0] "[kmcolor [lindex $player 2]]km" "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname [lindex $player 4]]] 3][lindex $cardofp 2]\003$add";
			}
		}
	}
	proc start {} {
		variable timestarted [clock seconds];
		if {[llength $::1000bornes::players]>1} {
			putquick "MODE $::1000bornes::chan +m"
			foreach player $::1000bornes::players {
				pushmode $::1000bornes::chan "+v" $player
			}
			flushmode $::1000bornes::chan;
			variable ingame 1;
			foreach card $::1000bornes::numbercards {
				lappend ::1000bornes::cards "[string repeat "[lindex $card 0] " [lindex $card 1]]"
			}
			variable cards [shuffle [join $::1000bornes::cards " "]];
			foreach player $::1000bornes::players {
				lappend ::1000bornes::playerinfo [list $player "[set cardsofplayer1 [lrange $::1000bornes::cards 0 5]]" "0" "0" "RedLight" {}]
				#Player Cards kms limited statut secret_weapon
				set cardsofplayer {}
				foreach cardofplayer $cardsofplayer1 {
					lappend cardsofplayer "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $cardofplayer]] 3][lindex $cardofp 1]\003";
				}
				::1000bornes::notc $player "Your cards are : %1." $cardsofplayer;
				variable ::1000bornes::cards [lreplace $::1000bornes::cards 0 5]
			}
			::1000bornes::next;			
		} else {
			::1000bornes::say $::1000bornes::chan "The game needs at least two player to begin."
			foreach player $::1000bornes::players {
				pushmode $::1000bornes::chan "-v" $player
			}
			flushmode $::1000bornes::chan;
			putquick "MODE $::1000bornes::chan -m"
			variable timestarted 0;
			variable started 0;
			variable ingame 0;
			variable timerstart "";
			variable playernow 0;
			variable cards "";
			variable playerinfo {};
			variable secretweaponskip {};
			variable players {};
		}
	}	
	proc game {nick host hand chan args} {
		if {[lsearch -exact -nocase $::1000bornes::players $nick]==-1} {
			if {$::1000bornes::started==0 && [llength $::1000bornes::players]==1} {
				::1000bornes::say $chan "The game can now start. You have %1 seconds to join the game by typing %2." $::1000bornes::timeoutstart [lindex $::1000bornes::join 0];
				variable timerstart [utimer $::1000bornes::timeoutstart ::1000bornes::start];
				variable started 1;
			}
			if {[set ::1000bornes::started]==1 && [llength $::1000bornes::players]<=$::1000bornes::maxplayers} {
				lappend ::1000bornes::players $nick;
				::1000bornes::notc $nick "You are now playing.";
			}
			if {$::1000bornes::started==0 && [llength $::1000bornes::players]==0} {
				::1000bornes::say $chan "%1 has just launched a game. Join him by typing %2." $nick [lindex $::1000bornes::join 0];
				lappend ::1000bornes::players $nick;
			}
		}
	}
	
	proc cardmalus {nick playercard statut nostatut victimname secretweapon secretweaponerror secretweaponsurprise canterror change} {
		if {$victimname eq ""} {
			::1000bornes::say $::1000bornes::chan "Who is your victim for the card %1?" "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			return 0;
		}
		if {$victimname eq $nick} {
			::1000bornes::say $::1000bornes::chan "You can't play %1 on yourself." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			return 0;
		}
		set victimid [lsearch -exact -nocase $::1000bornes::players $victimname];
		if {$victimid==-1} {
			::1000bornes::say $::1000bornes::chan "%1 is not playing." $victimname
			return 0;
		}
		set victim [lindex $::1000bornes::playerinfo $victimid]
		set victimcards [lindex $victim 1]
		set victimspeedometer [lindex $victim 2]
		set victimlimited [lindex $victim 3]
		set victimstatut [lindex $victim 4]
		set victimsecretweapon [lindex $victim 5]
		if {$statut eq "MaxSpeed"} {
			if {$victimlimited} {
				::1000bornes::say $::1000bornes::chan "$canterror" $victimname
				return 0
			}
		} else {
			if {$victimstatut ne $nostatut} {
				::1000bornes::say $::1000bornes::chan "$canterror" $victimname
				return 0
			}
		}
		if {[lsearch $victimsecretweapon "$secretweapon"]!=-1} {
			::1000bornes::say $::1000bornes::chan "$secretweaponerror"
			return 0
		}
		if {[lsearch $victimcards "$secretweapon"]==-1} {
			if {$statut eq "MaxSpeed"} {
				set victimlimited 1;
			} else {
				set victimstatut "$statut"
			}
			::1000bornes::say $::1000bornes::chan "$change" [lindex $victim 0]
		} else {
			lappend victimsecretweapon "$secretweapon"
			if {[::1000bornes::secretweaponadd $victimspeedometer]!=$victimspeedometer} {
				::1000bornes::say $::1000bornes::chan $secretweaponsurprise [lindex $victim 0] [::1000bornes::secretweaponadd $victimspeedometer]
			}
			set victimcards [lreplace $victimcards [set index [lsearch $victimcards "$secretweapon"]] $index]
			set cardnow [lindex $::1000bornes::cards 0];
			lappend ::1000bornes::secretweaponskip $victimid;
			lappend victimcards $cardnow;
			incr victimspeedometer [::1000bornes::secretweaponadd $victimspeedometer];
			if {$victimspeedometer==1000} {
				::1000bornes::end [lindex $victim 0];
				return 0;
			}
		}
		set victim [lreplace $victim 1 5 $victimcards $victimspeedometer $victimlimited $victimstatut $victimsecretweapon];
		set ::1000bornes::playerinfo [lreplace $::1000bornes::playerinfo $victimid $victimid $victim];
	}
	
	proc play {nick host hand chan text} {
		set args [split $text " "]
		set player [lindex $::1000bornes::playerinfo $::1000bornes::playernow]
		set playercards [lindex $player 1]
		set speedometer [lindex $player 2]
		set limited [lindex $player 3]
		set statut [lindex $player 4]
		set secretweapon [lindex $player 5]
		set cardofplayer [lsearch -index 1 -nocase $::1000bornes::cardsname [lindex $args 1]];
		if {[lindex $player 0] ne $nick} {
			::1000bornes::say $::1000bornes::chan "It's not your turn %1." $nick
			return 0;
		}
		if {[lsearch $playercards [lindex [lindex $::1000bornes::cardsname $cardofplayer] 0]]==-1} {
			::1000bornes::say $::1000bornes::chan "You don't have the card %1." [lindex $args 1]
			return 0;
		}
		set playercards [lreplace $playercards [set index [lsearch $playercards [lindex [lindex $::1000bornes::cardsname $cardofplayer] 0]]] $index]
		set playercard [lindex [lindex $::1000bornes::cardsname $cardofplayer] 0]
		
		if {$playercard eq "GreenLight"} {
			if {$statut ne "GreenLight"} {
				set statut "GreenLight"
				::1000bornes::say $::1000bornes::chan "%1, you can go now." $nick
			} else {
				::1000bornes::say $::1000bornes::chan "You don't need %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003";
				return 0;
			}
		} elseif {[string is integer $playercard]==1} {
			if {$statut eq "GreenLight"} {
				if {$playercard>50 && $limited} {
					::1000bornes::say $::1000bornes::chan "You can't go faster than 50km/h. Find a EndMaxSpeed."
					return 0;
				}
				incr speedometer $playercard
				if {$speedometer<=1000} {
					::1000bornes::say $::1000bornes::chan "You have moved of %1km. Now, your meter shows %2km." $playercard [kmcolor $speedometer];
					if {$speedometer==1000} {
						::1000bornes::end $nick;
						return 0;
					}
				}
			} else {
				::1000bornes::say $::1000bornes::chan "Wait, you need a green light before you can move."
				return 0;
			}
		} elseif {$playercard eq "RedLight"} {
			if {[cardmalus $nick $playercard RedLight GreenLight "[lindex $args 2]" Priority \
				"You can't stop an emergency vehicle like that." \
				"Surprise ! %1 drives an emergency vehicle. Because of your mistake he moved of %2km." \
				"But %1 is not moving." \
				"What an unlucky man %1, the light switched to red."]==0} {
				return 0;
			}
		} elseif {$playercard eq "MaxSpeed"} {
			if {[cardmalus $nick $playercard MaxSpeed "" "[lindex $args 2]" Priority \
				"You can't limit the speed of an emergency vehicle like that." \
				"Surprise ! %1 drives an emergency vehicle. Because of your mistake he moved of %2km." \
				"%1 has already a max speed." \
				"Aiiiie %1, you can't go faster than 50km/h."]==0} {
				return 0;
			}
		} elseif {$playercard eq "EndMaxSpeed"} {
			if {!$limited} {
				::1000bornes::say $::1000bornes::chan "You don't need %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003";
				return 0;
			}
			set limited 0;
			::1000bornes::say $::1000bornes::chan  "%1, you can go as fast as you can now." $nick
		} elseif {$playercard eq "OutGas"} {
			if {[cardmalus $nick $playercard OutGas GreenLight "[lindex $args 2]" Tank \
				"Have you ever seen a tank out of gas?" \
				"Surprise ! %1 drives a tank. Because of your mistake he moved of %2km." \
				"But %1 is not moving." \
				"Ohh %1, you are not lucky. You are out of gas."]==0} {
				return 0;
			}
		} elseif {$playercard eq "Gas"} {
			if {$statut ne "OutGas"} {
				::1000bornes::say $::1000bornes::chan "You don't need %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003";
				return 0;
			}
			set statut "Gas";
			if {[lsearch $secretweapon "Priority"]!=-1} {
				::1000bornes::say $::1000bornes::chan  "You have refueled."
			} else {
				::1000bornes::say $::1000bornes::chan  "You have refueled. Now you need a green light."
			}
		} elseif {$playercard eq "Accident"} {
			if {[cardmalus $nick $playercard Accident GreenLight "[lindex $args 2]" "AceDriver" \
				"A ace driver can't be implied in a accident." \
				"Surprise ! %1 is a ace driver. Because of your mistake he moved of %2km." \
				"But %1 is not moving." \
				"What a shame %1, you've hit a pole."]==0} {
				return 0;
			}
		} elseif {$playercard eq "Repairing"} {
			if {$statut ne "Accident"} {
				::1000bornes::say $::1000bornes::chan "You don't need %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003";
				return 0;
			}
			set statut "Repairing";
			if {[lsearch $secretweapon "Priority"]!=-1} {
				::1000bornes::say $::1000bornes::chan "Your car is now fully repaired."
			} else {
				::1000bornes::say $::1000bornes::chan "Your car is now fully repaired. Now you need a green light."
			}
		} elseif {$playercard eq "Flat"} {
			if {[cardmalus $nick $playercard Flat GreenLight "[lindex $args 2]" "Puncture-Proof" \
				"How can you burst a puncture-proof wheel?" \
				"Surprise ! %1 has puncture-proof wheels. Because of your mistake he moved of %2km." \
				"But %1 is not moving." \
				"Ohh %1, you are not lucky. Your wheels are flat."]==0} {
				return 0;
			}
		} elseif {$playercard eq "SpareWheel"} {
			if {$statut ne "Flat"} {
				::1000bornes::say $::1000bornes::chan "You don't need %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003";
				return 0;
			}
			set statut "SpareWheel";
			if {[lsearch $secretweapon "Priority"]!=-1} {
				::1000bornes::say $::1000bornes::chan  "You have a brand new wheel."
			} else {
				::1000bornes::say $::1000bornes::chan  "You have a brand new wheel. Now you need a green light."
			}
		} elseif {$playercard eq "Priority"} {
			set limited 0;
			incr speedometer 100
			lappend secretweapon "Priority"
			::1000bornes::say $::1000bornes::chan "%1 use the secret weapon %2 so he move of 100km." $nick "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			if {$speedometer<=1000} {
				if {$speedometer==1000} {
					::1000bornes::end $nick;
					return 0;
				}
			}
		} elseif {$playercard eq "AceDriver"} {
			incr speedometer 100
			lappend secretweapon "AceDriver"
			if {$statut eq "Accident"} {
				set statut "Repairing";
			}
			::1000bornes::say $::1000bornes::chan "%1 use the secret weapon %2 so he move of 100km." $nick "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			if {$speedometer<=1000} {
				if {$speedometer==1000} {
					::1000bornes::end $nick;
					return 0;
				}
			}
		} elseif {$playercard eq "Puncture-Proof"} {
			incr speedometer 100
			lappend secretweapon "Puncture-Proof"
			if {$statut eq "Flat"} {
				set statut "SpareWheel";
			}
			::1000bornes::say $::1000bornes::chan "%1 use the secret weapon %2 so he move of 100km." $nick "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			if {$speedometer<=1000} {
				if {$speedometer==1000} {
					::1000bornes::end $nick;
					return 0;
				}
			}
		} elseif {$playercard eq "Tank"} {
			lappend secretweapon "Tank"
			incr speedometer 100
			if {$statut eq "OutGas"} {
				set statut "Gas";
			}
			::1000bornes::say $::1000bornes::chan "%1 use the secret weapon %2 so he move of 100km." $nick "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			if {$speedometer<=1000} {
				if {$speedometer==1000} {
					::1000bornes::end $nick;
					return 0;
				}
			}
		}
		if {$speedometer>1000} {
			::1000bornes::say $::1000bornes::chan "You tought you were clever by going farther than the 1000kms mark but you just lost."
			::1000bornes::excl $nick 0;
			return 0;
		}
		if {[lsearch $secretweapon "Priority"]!=-1} {
			if {$statut eq "RedLight" || $statut eq "Repairing" || $statut eq "SpareWheel" || $statut eq "Gas"} {
				set statut "GreenLight";
			}
		}
		set player [lreplace $player 1 5 $playercards $speedometer $limited $statut $secretweapon];
		set ::1000bornes::playerinfo [lreplace $::1000bornes::playerinfo $::1000bornes::playernow $::1000bornes::playernow $player];
		
		if {[expr $::1000bornes::playernow+2]>[llength $::1000bornes::players]} {
			set ::1000bornes::playernow 0;
		} else {
			incr ::1000bornes::playernow;
		}
		::1000bornes::next;
	}
	proc throw {nick host hand chan text} {
		set args [split $text " "]
		set player [lindex $::1000bornes::playerinfo $::1000bornes::playernow]
		set playercards [lindex $player 1]
		set speedometer [lindex $player 2]
		set limited [lindex $player 3]
		set statut [lindex $player 4]
		set cardofplayer [lsearch -index 1 -nocase $::1000bornes::cardsname [lindex $args 1]];
		if {[lindex $player 0] ne $nick} {
			::1000bornes::say $::1000bornes::chan "It's not your turn %1." $nick
			return 0;
		}
		if {[lsearch $playercards [lindex [lindex $::1000bornes::cardsname $cardofplayer] 0]]>-1} {
			set playercards [lreplace $playercards [set index [lsearch $playercards [lindex [lindex $::1000bornes::cardsname $cardofplayer] 0]]] $index]
			set playercard [lindex [lindex $::1000bornes::cardsname $cardofplayer] 0]
			::1000bornes::say $::1000bornes::chan "You throw that card %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $playercard]] 3][lindex $cardofp 1]\003"
			lappend ::1000bornes::cards $playercard
			set player [lreplace $player 1 4 $playercards $speedometer $limited $statut];
			set ::1000bornes::playerinfo [lreplace $::1000bornes::playerinfo $::1000bornes::playernow $::1000bornes::playernow $player];
		} else {
			::1000bornes::say $::1000bornes::chan "You don't have the card %1." [lindex $args 1]
			return 0;
		}
		if {[expr $::1000bornes::playernow+2]>[llength $::1000bornes::players]} {
			set ::1000bornes::playernow 0;
		} else {
			incr ::1000bornes::playernow;
		}
		::1000bornes::next;
	}
	proc giveupcmd {nick host hand chan args} {
		::1000bornes::giveup $nick;
	}
	proc giveuppart {nick host hand chan {msg ""}} {
		::1000bornes::giveup $nick;
	}
	proc kick {nick host hand chan target reason} {
		::1000bornes::excl $target 1;
	}
	proc giveup {nick} {
		if {[lsearch -exact -nocase $::1000bornes::players $nick]>-1} {
			set player [lindex $::1000bornes::playerinfo $::1000bornes::playernow]
			variable players [lreplace $::1000bornes::players [set index [lsearch -exact -nocase $::1000bornes::players $nick]] $index];
			variable playerinfo [lreplace $::1000bornes::playerinfo $index $index];
			::1000bornes::say $::1000bornes::chan "%1 has just given up." $nick
			pushmode $::1000bornes::chan "-v" "$nick"
			flushmode $::1000bornes::chan;
			if {$::1000bornes::ingame==0} {
				return 0;
			}
			if {[llength $::1000bornes::players]==1} {
				::1000bornes::end [lindex $::1000bornes::players 0];
			} else {
				if {[lindex $player 0] eq $nick} {
					if {[expr $::1000bornes::playernow+2]>[llength $::1000bornes::players]} {
						set ::1000bornes::playernow 0;
					} else {
						incr ::1000bornes::playernow;
					}
					::1000bornes::next;
				}
			}
		}
	}
	proc excl {nick send} {
		if {[lsearch -exact -nocase $::1000bornes::players $nick]>-1} {
			set player [lindex $::1000bornes::playerinfo $::1000bornes::playernow]
			variable players [lreplace $::1000bornes::players [set index [lsearch -exact -nocase $::1000bornes::players $nick]] $index];
			variable playerinfo [lreplace $::1000bornes::playerinfo $index $index];
			if {$send==1} {
				::1000bornes::say $::1000bornes::chan "%1 has been eliminated." $nick
			}
			pushmode $::1000bornes::chan "-v" "$nick"
			flushmode $::1000bornes::chan;
			if {[llength $::1000bornes::players]==1} {
				::1000bornes::end [lindex $::1000bornes::players 0];
			} else {
				if {[lindex $player 0] eq $nick} {
					if {[expr $::1000bornes::playernow+2]>[llength $::1000bornes::players]} {
						set ::1000bornes::playernow 0;
					} else {
						incr ::1000bornes::playernow;
					}
					::1000bornes::next;
				}
			}
		}
	}
	proc recall {player} {
		variable timeouts [lreplace $::1000bornes::timeouts 0 0];
		::1000bornes::say $::1000bornes::chan "Hey %1, wake up. You have only %2 minute left." $player [string trimright [format %#0.2g [expr ($::1000bornes::timeoutplayer-$::1000bornes::timeoutplayerrecall)/60]] .0]
	}
	proc lastrecall {player} {
		variable timeouts [lreplace $::1000bornes::timeouts 0 0];
		::1000bornes::say $::1000bornes::chan "%1, you have only %2 seconds to play before you are eliminated." $player [expr ($::1000bornes::timeoutplayer-$::1000bornes::timeoutplayerrecalllast)]
	}
	proc timeout {player} {
		variable timeouts [lreplace $::1000bornes::timeouts 0 0];
		::1000bornes::excl $player 1;
	}
	proc next {} {
		if {$::1000bornes::timeouts ne {}} {
			foreach timeout $::1000bornes::timeouts {
				killutimer $timeout;
			}
			variable timeouts {};
		}
		set player [lindex $::1000bornes::playerinfo $::1000bornes::playernow]
		set playercards [lindex $player 1]
		set speedometer [lindex $player 2]
		set limited [lindex $player 3]
		set statut [lindex $player 4]
		set secretweapon [lindex $player 5]
		set cardnow [lindex $::1000bornes::cards 0];
		if {[set idskip [lsearch -exact $::1000bornes::secretweaponskip $::1000bornes::playernow]]==-1} {
			::1000bornes::say $::1000bornes::chan "It's the turn of %1." [lindex $player 0]
			lappend playercards $cardnow;
			if {[lsearch $secretweapon "Priority"]!=-1} {
				if {$statut eq "RedLight" || $statut eq "Repairing" || $statut eq "SpareWheel" || $statut eq "Gas"} {
					set statut "GreenLight";
				}
			}
			set player [lreplace $player 1 5 $playercards $speedometer $limited $statut $secretweapon];
			set ::1000bornes::playerinfo [lreplace $::1000bornes::playerinfo $::1000bornes::playernow $::1000bornes::playernow $player];
			set playercard2 {}
			foreach cardofplayer $playercards {
				lappend playercard2 "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $cardofplayer]] 3][lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $cardofplayer]] 1]\003";
			}
			set add "";
			if {$limited} {
				set add [concat $add "\003[lindex [set limit [lsearch -index 0 -inline $::1000bornes::cardsname "MaxSpeed"]] 3][lindex $limit 2]\003"]
			}
			if {[llength $secretweapon]>0} {
				set secretweapons [list "| $::1000bornes::secretweaponname :"];
				foreach weapon $secretweapon {
					lappend secretweapons "\003[lindex [set weapon1 [lsearch -index 0 -inline $::1000bornes::cardsname $weapon]] 3][lindex $weapon1 2]\003,";
				}
				set add [concat $add [string trimright [join $secretweapons] ,]];
			}
			::1000bornes::say $::1000bornes::chan "Speedometer : %1 | Statut : %2" "[kmcolor [lindex $player 2]]km" "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname [lindex $player 4]]] 3][lindex $cardofp 2]\003 $add";
			::1000bornes::say $::1000bornes::chan "To play : \002%1 <card> <player>\002 | \002%2 <card>\002." [lindex $::1000bornes::play 0] [lindex $::1000bornes::throw 0];
			::1000bornes::notc [lindex $player 0] "You've taken the card : %1." "\003[lindex [set cardofp [lsearch -index 0 -inline $::1000bornes::cardsname $cardnow]] 3][lindex $cardofp 1]\003"
			::1000bornes::notc [lindex $player 0] "So your cards are : %1." $playercard2
			variable ::1000bornes::cards [lreplace $::1000bornes::cards 0 0]
			lappend ::1000bornes::timeouts [utimer $::1000bornes::timeoutplayerrecall [list ::1000bornes::recall [lindex $player 0]]]
			lappend ::1000bornes::timeouts [utimer $::1000bornes::timeoutplayerrecalllast [list ::1000bornes::lastrecall [lindex $player 0]]]
			lappend ::1000bornes::timeouts [utimer $::1000bornes::timeoutplayer [list ::1000bornes::timeout [lindex $player 0]]]
		} else {
			set ::1000bornes::secretweaponskip [lreplace $::1000bornes::secretweaponskip $idskip $idskip]
			::1000bornes::say $::1000bornes::chan "%1 has used a secret weapon to protect himself. So he skip his turn." [lindex $player 0]
			if {[expr $::1000bornes::playernow+2]>[llength $::1000bornes::players]} {
				set ::1000bornes::playernow 0;
			} else {
				incr ::1000bornes::playernow;
			}
			::1000bornes::next;
		}
	}
	
	proc end {winner} {
		if {$winner ne ""} {
			::1000bornes::say $::1000bornes::chan "The winner is %1." $winner;
		} else {
			::1000bornes::say $::1000bornes::chan "There is no winner." $winner;
		}
		if {[set diff [expr [clock seconds]-$::1000bornes::timestarted]]>=3600 && [clock seconds]!=$diff} {
			set time [clock format $diff -format $::1000bornes::timeformatwithhour -gmt 1]
		} elseif {$diff>60 && [clock seconds]!=$diff} {
			set time [clock format $diff -format $::1000bornes::timeformatwithouthour -gmt 1]
		} elseif {[clock seconds]!=$diff} {
			set time [clock format $diff -format $::1000bornes::timeformatsecondsonly -gmt 1]
		} else {
			set time [string map {"%S" "0"} $::1000bornes::timeformatsecondsonly]
		}
		::1000bornes::say $::1000bornes::chan "The game ends after %1." $time
		foreach player $::1000bornes::players {
			pushmode $::1000bornes::chan "-v" $player
		}
		putquick "MODE $::1000bornes::chan -m"
		flushmode $::1000bornes::chan;
		variable timestarted 0;
		variable started 0;
		variable ingame 0;
		variable timerstart "";
		variable playernow 0;
		variable cards "";
		variable playerinfo {};
		variable secretweaponskip {};
		if {$::1000bornes::timeouts ne {}} {
			foreach timeout $::1000bornes::timeouts {
				killutimer $timeout;
			}
			variable timeouts {};
		}
		variable players {};
	}
	
	proc stop {nick host hand chan args} {
		if {$::1000bornes::started==1} {
			if {$::1000bornes::ingame==0} {
				killutimer $::1000bornes::timerstart;
			}
			::1000bornes::say $::1000bornes::chan "%1 has just stopped the game." $nick;
			::1000bornes::end "";
		}
	}
	
	proc uninstall {args} {
		foreach joincmd $::1000bornes::join {
			unbind pubm -|- "$::1000bornes::chan %$joincmd" ::1000bornes::game;
			unbind pubm -|- "$::1000bornes::chan %$joincmd *" ::1000bornes::game;
		}
		foreach playcmd $::1000bornes::play {
			unbind pubm -|- "$::1000bornes::chan %$playcmd *" ::1000bornes::play;
		}
		foreach throwcmd $::1000bornes::throw {
			unbind pubm -|- "$::1000bornes::chan %$throwcmd *" ::1000bornes::throw;
		}
		foreach giveupcmd $::1000bornes::giveup {
			unbind pubm -|- "$::1000bornes::chan %$giveupcmd" ::1000bornes::giveupcmd;
		}
		foreach cardscmd $::1000bornes::cardscmd {
			unbind pubm -|- "$::1000bornes::chan %$cardscmd" ::1000bornes::cards;
		}
		if {$::1000bornes::timeouts ne {}} {
			foreach timeout $::1000bornes::timeouts {
				killutimer $timeout;
			}
			variable timeouts {};
		}
		foreach startcmd $::1000bornes::startcmds {
			unbind pubm n|o "$::1000bornes::chan %$startcmd" ::1000bornes::startcmd;
		}
		foreach stopcmd $::1000bornes::stopcmds {
			unbind pubm n|o "$::1000bornes::chan %$stopcmd" ::1000bornes::stop;
		}
		foreach statutcmd $::1000bornes::statutcmds {
			unbind pubm -|- "$::1000bornes::chan %$statutcmd" ::1000bornes::statut;
		}
		foreach helpcmd $::1000bornes::helpcmds {
			unbind pubm -|- "$::1000bornes::chan %$helpcmd" ::1000bornes::helpcmd;
		}
		unbind part -|- "$::1000bornes::chan *!*@*" ::1000bornes::giveuppart;
		unbind sign -|- "$::1000bornes::chan *!*@*" ::1000bornes::giveuppart;
		unbind nick -|- "$::1000bornes::chan *" ::1000bornes::nick;
		namespace delete ::1000bornes;
		putlog "1000 bornes by jolo2 has been unloaded";
	}
}

putlog "1000 bornes (v1.0.1) by jolo2 has been loaded";